"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fileMatcher_1 = require("./fileMatcher");
var TestFiles_1 = require("./TestFiles");
var Runner_1 = require("./Runner");
var Watcher_1 = require("./Watcher");
var Preference_1 = require("./Preference");
var launchEditor = require('react-dev-utils/launchEditor');
var readPkgUp = require('read-pkg-up');
var Engine = /** @class */ (function () {
    function Engine(rootPath, config) {
        this.root = rootPath;
        this.testMatcher = fileMatcher_1.getTestPatternsMatcher(rootPath, config);
        this.testFiles = new TestFiles_1.default(this);
        this.preference = new Preference_1.default();
        this.testRunner = new Runner_1.default(this, config, this.preference);
        this.watcher = new Watcher_1.default(rootPath, config);
    }
    Engine.prototype.launchEditor = function (path, lineNo) {
        launchEditor(path, lineNo);
    };
    Engine.prototype.getVersion = function () {
        return readPkgUp({
            cwd: __dirname
        }).then(function (result) {
            return result.pkg.version;
        });
    };
    return Engine;
}());
exports.default = Engine;
//# sourceMappingURL=index.js.map