"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var styled_components_1 = require("styled-components");
var mobx_react_1 = require("mobx-react");
var RunPanel_1 = require("./summaryPanel/RunPanel");
var executionSummary_1 = require("./summaryPanel/executionSummary");
var coverageSummary_1 = require("./summaryPanel/coverageSummary");
var Footer_1 = require("./summaryPanel/Footer");
var Preference_1 = require("./Preference");
var FailedTests_1 = require("./summaryPanel/FailedTests");
var bookmarks_1 = require("./bookmarks");
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 350px;\n  height: 100;\n  display: flex;\n  justify-content: space-between;\n  flex-direction: column;\n  background-color: ", " !important;\n  box-shadow: none !important;\n  color: ", " !important;\n  padding-bottom: 0px !important;\n"], ["\n  width: 350px;\n  height: 100;\n  display: flex;\n  justify-content: space-between;\n  flex-direction: column;\n  background-color: ", " !important;\n  box-shadow: none !important;\n  color: ", " !important;\n  padding-bottom: 0px !important;\n"])), function (props) { return props.theme.main; }, function (props) { return props.theme.text; });
var Body = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  flex-grow: 1;\n"], ["\n  display: flex;\n  flex-direction: column;\n  flex-grow: 1;\n"])));
function SummaryPanel(_a) {
    var workspace = _a.workspace, tests = _a.tests, preference = _a.preference, updater = _a.updater;
    return (React.createElement(Container, { className: "pt-card pt-dark" },
        React.createElement(Body, null,
            React.createElement(RunPanel_1.default, { onRunTests: function () {
                    workspace.run();
                    if (workspace.isExecuting) {
                        tests.resetStatus();
                    }
                    else {
                        tests.executeAllItBlocks();
                    }
                }, isCoverageDisabled: workspace.diableCoverage, onCoverageDisableChange: function () {
                    workspace.toggleCoverage();
                }, isWatching: workspace.watch, toggleWatch: function () {
                    workspace.toggleWatch();
                }, isExecuting: workspace.isExecuting }),
            React.createElement(executionSummary_1.default, { executionSummary: tests.executionSummary, isRunning: workspace.isExecuting }),
            React.createElement(coverageSummary_1.default, { coverageSummary: tests.coverageSummary }),
            React.createElement(bookmarks_1.default, { bookmarks: workspace.bookmarks, onClick: function (path) {
                    tests.changeCurrentSelection(path);
                } }),
            React.createElement(FailedTests_1.default, { failedTetsts: tests.failedTests, onChangeCurrentSelection: tests.changeCurrentSelection })),
        React.createElement(Footer_1.default, { version: updater.version, onPreferenceClick: function () {
                preference.togglePreferenceModal(true);
            } }),
        React.createElement(Preference_1.default, { preference: preference })));
}
exports.default = mobx_react_1.observer(SummaryPanel);
var templateObject_1, templateObject_2;
//# sourceMappingURL=SummaryPanel.js.map