"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactVirtualized = require('react-virtualized');
var styled_components_1 = require("styled-components");
require("react-virtualized/styles.css");
var mobx_react_1 = require("mobx-react");
var styled_1 = require("../util/styled");
var theme_1 = require("../theme");
var Scrollbars = require('react-custom-scrollbars').Scrollbars;
var Tooltip = require('react-tippy').Tooltip;
var ObservedList = mobx_react_1.observer(ReactVirtualized.List);
var ItemUl = styled_components_1.default.ul(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  padding-left: 15px;\n  margin-top: 0;\n  margin-bottom: 0;\n  list-style: none;\n  margin-bottom: '3px';\n"], ["\n  padding-left: 15px;\n  margin-top: 0;\n  margin-bottom: 0;\n  list-style: none;\n  margin-bottom: '3px';\n"])));
var ItemSpan = styled_components_1.default.span(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  padding-right: 5px;\n  font-size: 13px !important;\n"], ["\n  padding-right: 5px;\n  font-size: 13px !important;\n"])));
var StatusDotElement = styled_1.styledComponentWithProps(styled_components_1.default.span);
var StatusDot = StatusDotElement(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\ncolor: ", ";\n"], ["\ncolor: ", ";\n"])), function (props) { return theme_1.getColorForStatus(props.status); });
var ItemDivElement = styled_1.styledComponentWithProps(styled_components_1.default.div);
var ItemDiv = ItemDivElement(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  cursor: pointer;\n  color: ", ";\n  display: flex;\n  height: 20px;\n  margin-left: ", "\n  justify-content: space-between;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n"], ["\n  cursor: pointer;\n  color: ", ";\n  display: flex;\n  height: 20px;\n  margin-left: ", "\n  justify-content: space-between;\n  white-space: nowrap;\n  overflow: hidden;\n  text-overflow: ellipsis;\n"])), function (props) { return (props.selected ? props.theme.extra.mars : 'white'); }, function (props) { return (props.type === 'file' ? '5px' : '0px'); });
var ItemNode = /** @class */ (function (_super) {
    __extends(ItemNode, _super);
    function ItemNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ItemNode_1 = ItemNode;
    ItemNode.prototype.render = function () {
        var _a = this.props, item = _a.item, onItemClick = _a.onItemClick, onToggle = _a.onToggle;
        var props = { key: item.path };
        var children = [];
        var itemText;
        if (item.isExpanded && item.children) {
            children = item.children.map(function (child, index) {
                return (React.createElement(ItemNode_1, { key: child.path, item: child, onItemClick: onItemClick, onToggle: onToggle }));
            });
        }
        itemText = item.label;
        var icon = item.type === 'directory' ? 'pt-icon-folder-close' : 'pt-icon-document';
        var toggleIcon = '';
        if (item.type === 'directory') {
            toggleIcon = item.isExpanded
                ? 'pt-icon-caret-down'
                : 'pt-icon-caret-right';
        }
        children.unshift(React.createElement(ItemDiv, { className: "item", key: "label", status: item.status, selected: item.isSelected || false, type: item.type, onClick: function (event) {
                event.stopPropagation();
                if (item.type !== 'directory') {
                    onItemClick(item);
                }
                else {
                    item.isExpanded = !item.isExpanded;
                    onToggle();
                }
            } },
            React.createElement("div", null,
                React.createElement(ItemSpan, { className: "pt-icon-standard " + toggleIcon }),
                React.createElement(ItemSpan, { className: "pt-icon-standard " + icon }),
                itemText,
                item.type === 'file' &&
                    item.status !== 'pending' && (React.createElement(Tooltip, { title: item.status, position: "right", trigger: "mouseenter" },
                    React.createElement(StatusDot, { status: item.status, className: "pt-icon-standard pt-icon-dot" }))))));
        return (React.createElement(ItemUl, null,
            React.createElement("li", __assign({}, props), children)));
    };
    ItemNode = ItemNode_1 = __decorate([
        mobx_react_1.observer
    ], ItemNode);
    return ItemNode;
    var ItemNode_1;
}(React.Component));
var Tree = /** @class */ (function (_super) {
    __extends(Tree, _super);
    function Tree() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ROW_HEIGHT = 20;
        _this.rowHeight = function (params) {
            return (_this.getExpandedItemCount(_this.props.nodes[params.index]) *
                _this.ROW_HEIGHT);
        };
        _this.renderItem = function (item) {
            return (React.createElement(ItemNode, { item: item, onItemClick: function (clickedItem) {
                    _this.props.onSearchItemClick(clickedItem);
                }, onToggle: function () {
                    _this.List.recomputeRowHeights();
                    _this.List.forceUpdate();
                } }));
        };
        _this.getExpandedItemCount = function (item) {
            var totalcount = 1;
            if (item.isExpanded) {
                totalcount += item.children
                    .map(_this.getExpandedItemCount)
                    .reduce(function (total, count) {
                    return total + count;
                }, 0);
            }
            return totalcount;
        };
        _this.cellRenderer = function (params) {
            var renderedCell = _this.renderItem(_this.props.nodes[params.index]);
            return (React.createElement("ul", { style: __assign({}, params.style, { paddingLeft: '0px', margin: '0', marginLeft: '-14px' }), key: _this.props.nodes[params.index].path }, renderedCell));
        };
        _this.handleScroll = function (_a) {
            var target = _a.target;
            var scrollTop = target.scrollTop, scrollLeft = target.scrollLeft;
            var grid = _this.List.Grid;
            grid.handleScrollEvent({ scrollTop: scrollTop, scrollLeft: scrollLeft });
        };
        return _this;
    }
    Tree.prototype.render = function () {
        var _this = this;
        console.log(this.props.nodes.length);
        return (React.createElement(Scrollbars, { style: { height: 'calc(100vh - 62px)' } },
            React.createElement(ReactVirtualized.AutoSizer, null, function (params) {
                return (React.createElement(ObservedList, { height: params.height - 100, overscanRowCount: 10, ref: function (list) { return (_this.List = list); }, rowHeight: _this.rowHeight, rowRenderer: _this.cellRenderer, rowCount: _this.props.nodes.length, width: params.width - 30, style: {
                        overflowX: false,
                        overflowY: false
                    } }));
            })));
    };
    Tree = __decorate([
        mobx_react_1.observer
    ], Tree);
    return Tree;
}(React.Component));
exports.default = Tree;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=Tree.js.map