"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var styled_components_1 = require("styled-components");
var polished_1 = require("polished");
var mobx_react_1 = require("mobx-react");
var PrimaryElement = styled_components_1.default.button(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  border-radius: 3px;\n  border: 0;\n  background-color: ", ";\n  color: white;\n  padding: 6px;\n  cursor: pointer;\n  min-width: 150px;\n  min-height: 31px;\n  display: flex;\n  align-self: auto;\n  justify-content: center;\n  align-items: center;\n  font-weight: 600;\n\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n\n  &:focus {\n    outline: none;\n  }\n"], ["\n  border-radius: 3px;\n  border: 0;\n  background-color: ", ";\n  color: white;\n  padding: 6px;\n  cursor: pointer;\n  min-width: 150px;\n  min-height: 31px;\n  display: flex;\n  align-self: auto;\n  justify-content: center;\n  align-items: center;\n  font-weight: 600;\n\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n\n  &:focus {\n    outline: none;\n  }\n"])), function (props) { return props.theme.primary; }, function (props) { return polished_1.darken(0.1, props.theme.primary); }, function (props) { return polished_1.darken(0.2, props.theme.primary); });
var SecondaryElement = PrimaryElement.extend(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  background-color: ", ";\n  color: ", ";\n\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n"], ["\n  background-color: ", ";\n  color: ", ";\n\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n"])), function (props) { return props.theme.secondary; }, function (props) { return props.theme.main; }, function (props) { return polished_1.darken(0.1, props.theme.secondary); }, function (props) { return polished_1.darken(0.2, props.theme.secondary); });
var MinimalElement = PrimaryElement.extend(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  background-color: inherit;\n  color: ", ";\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n"], ["\n  background-color: inherit;\n  color: ", ";\n  &:hover {\n    background-color: ", ";\n  }\n\n  &:active {\n    background-color: ", ";\n  }\n"])), function (props) { return props.theme.text; }, function (props) { return polished_1.lighten(0.2, props.theme.main); }, function (props) { return polished_1.lighten(0.2, props.theme.main); });
var ButtonSpan = styled_components_1.default.span(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  margin-right: 10px;\n  margin-top: 2px;\n"], ["\n  margin-right: 10px;\n  margin-top: 2px;\n"])));
function Button(_a) {
    var label = _a.label, primary = _a.primary, minimal = _a.minimal, className = _a.className, icon = _a.icon, isActive = _a.isActive, onClick = _a.onClick, children = _a.children;
    var Element = primary ? PrimaryElement : SecondaryElement;
    Element = minimal ? MinimalElement : Element;
    return (React.createElement(Element, { className: className, onClick: onClick },
        !children && (React.createElement(React.Fragment, null,
            icon && React.createElement(ButtonSpan, null, icon),
            React.createElement("span", null, label))),
        children));
}
exports.default = mobx_react_1.observer(Button);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=index.js.map