"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var styled_components_1 = require("styled-components");
var mobx_react_1 = require("mobx-react");
var polished_1 = require("polished");
var theme_1 = require("../../theme");
var _a = require('react-inspector'), ObjectInspector = _a.ObjectInspector, chromeDark = _a.chromeDark;
var Scrollbars = require('react-custom-scrollbars').Scrollbars;
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: column;\n  height: 300px;\n  padding: 5px;\n  background-color: ", ";\n  box-shadow: 0 4px 6px 0 hsla(0, 0%, 0%, 0.2) !important;\n"], ["\n  display: flex;\n  flex-direction: column;\n  height: 300px;\n  padding: 5px;\n  background-color: ", ";\n  box-shadow: 0 4px 6px 0 hsla(0, 0%, 0%, 0.2) !important;\n"])), function (props) { return polished_1.darken(0.1, props.theme.main); });
var LogEntry = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin-bottom: 4px;\n"], ["\n  margin-bottom: 4px;\n"])));
var Info = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  color: ", ";\n  display: flex;\n  justify-content: center;\n  flex-direction: column;\n  text-align: center;\n  height: 100%;\n  font-size: 15px;\n\n  & span {\n    font-weight: 600;\n    color: ", ";\n    background-color: ", ";\n    border-radius: 4px;\n    padding-left: 5px;\n    padding-right: 5px;\n  }\n"], ["\n  color: ", ";\n  display: flex;\n  justify-content: center;\n  flex-direction: column;\n  text-align: center;\n  height: 100%;\n  font-size: 15px;\n\n  & span {\n    font-weight: 600;\n    color: ", ";\n    background-color: ", ";\n    border-radius: 4px;\n    padding-left: 5px;\n    padding-right: 5px;\n  }\n"])), function (props) { return props.theme.text; }, function (props) { return props.theme.main; }, function (props) { return props.theme.extra.mars; });
function Console(_a) {
    var debug = _a.debug;
    return (React.createElement(Container, null,
        debug.isLogsAvailable && (React.createElement(Scrollbars, { style: { height: '400px' } },
            debug.logs.map(function (log, i) { return (React.createElement(LogEntry, null,
                React.createElement(ObjectInspector, { theme: __assign({}, chromeDark, {
                        BASE_BACKGROUND_COLOR: polished_1.darken(0.1, theme_1.default.main),
                        TREENODE_FONT_SIZE: '13px'
                    }), key: i, data: log }))); }),
            "/>")),
        !debug.isLogsAvailable && (React.createElement(Info, null,
            React.createElement("div", null,
                "Use ",
                React.createElement("span", null, "majestic.log()"),
                " in your tests and inspect them here")))));
}
exports.default = mobx_react_1.observer(Console);
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=index.js.map