"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var styled_components_1 = require("styled-components");
var mobx_react_1 = require("mobx-react");
var SelfBuildingSquare_1 = require("../spinners/SelfBuildingSquare");
var _a = require('react-feather'), Eye = _a.Eye, EyeOff = _a.EyeOff, Play = _a.Play;
var core_1 = require("@blueprintjs/core");
var polished_1 = require("polished");
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n"], ["\n  display: flex;\n"])));
var PlayButton = styled_components_1.default(core_1.Button)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  background-color: ", " !important;\n"], ["\n  background-color: ", " !important;\n"])), function (props) { return props.theme.primary; });
var WatchButton = styled_components_1.default(core_1.Button)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  background-color: ", " !important;\n  color: ", " !important;\n"], ["\n  background-color: ", " !important;\n  color: ", " !important;\n"])), function (props) { return props.theme.secondary; }, function (props) { return props.theme.main; });
var MoreButton = styled_components_1.default(core_1.AnchorButton)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  background-color: ", " !important;\n  color: ", " !important;\n"], ["\n  background-color: ", " !important;\n  color: ", " !important;\n"])), function (props) { return props.theme.secondary; }, function (props) { return props.theme.main; });
var ButtonPanel = styled_components_1.default(core_1.ButtonGroup)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  width: 100%;\n"], ["\n  width: 100%;\n"])));
var RunOptions = styled_components_1.default.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  background-color: ", " !important;\n  width: 300px;\n  height: 100px;\n  padding: 15px;\n  border-radius: 5px;\n"], ["\n  background-color: ", " !important;\n  width: 300px;\n  height: 100px;\n  padding: 15px;\n  border-radius: 5px;\n"])), function (props) { return polished_1.lighten(0.2, props.theme.main); });
var RunOptionHeading = styled_components_1.default.div(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  margin-bottom: 10px;\n  font-size: 14px;\n"], ["\n  margin-bottom: 10px;\n  font-size: 14px;\n"])));
function RunPanel(_a) {
    var onRunTests = _a.onRunTests, isWatching = _a.isWatching, isExecuting = _a.isExecuting, toggleWatch = _a.toggleWatch, isCoverageDisabled = _a.isCoverageDisabled, onCoverageDisableChange = _a.onCoverageDisableChange;
    var runLabel = isExecuting ? 'Stop' : 'Run';
    var watchLabel = isWatching ? 'Stop watching' : 'Watch';
    var WatchIcon = isWatching ? React.createElement(EyeOff, { size: 16 }) : React.createElement(Eye, { size: 16 });
    var icon = isExecuting ? React.createElement(SelfBuildingSquare_1.default, null) : React.createElement(Play, { size: 16 });
    return (React.createElement(Container, null,
        React.createElement(ButtonPanel, { fill: true, minimal: false },
            React.createElement(PlayButton, { icon: icon, onClick: function () {
                    onRunTests();
                } }, runLabel),
            React.createElement(WatchButton, { icon: WatchIcon, onClick: function () {
                    toggleWatch();
                } }, watchLabel),
            React.createElement(core_1.Popover, { position: core_1.Position.BOTTOM, content: React.createElement(RunOptions, null,
                    React.createElement(RunOptionHeading, null, "Additional run options"),
                    React.createElement(core_1.Switch, { checked: isCoverageDisabled, onChange: onCoverageDisableChange, label: "Disable coverage collection" })) },
                React.createElement(MoreButton, { rightIcon: "more" })))));
}
exports.default = mobx_react_1.observer(RunPanel);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
//# sourceMappingURL=RunPanel.js.map