"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var styled_components_1 = require("styled-components");
var core_1 = require("@blueprintjs/core");
var polished_1 = require("polished");
var _a = require('react-feather'), ChevronUp = _a.ChevronUp, ChevronDown = _a.ChevronDown, Trash = _a.Trash;
var consolePanel_1 = require("../consolePanel");
var mobx_react_1 = require("mobx-react");
var Container = styled_components_1.default.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  background-color: ", ";\n"], ["\n  background-color: ", ";\n"])), function (props) { return polished_1.lighten(0.1, props.theme.main); });
var Handle = styled_components_1.default.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  display: flex;\n  justify-content: space-between;\n  background-color: ", ";\n"], ["\n  display: flex;\n  justify-content: space-between;\n  background-color: ", ";\n"])), function (props) { return polished_1.darken(0.1, props.theme.main); });
var ToggleButton = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  margin-top: 7px;\n  margin-right: 5px;\n  margin-left: 5px;\n\n  > svg {\n    cursor: pointer;\n\n    &:hover {\n      stroke: gray;\n    }\n  }\n"], ["\n  margin-top: 7px;\n  margin-right: 5px;\n  margin-left: 5px;\n\n  > svg {\n    cursor: pointer;\n\n    &:hover {\n      stroke: gray;\n    }\n  }\n"])));
var ToggleButtons = styled_components_1.default.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n"], ["\n  display: flex;\n  flex-direction: row;\n"])));
var TabHandle = styled_components_1.default.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-between;\n  padding: 5px;\n  padding-top: 7px;\n  padding-left: 10px;\n  width: 92px;\n  font-weight: 600;\n  background-color: ", ";\n  color: ", ";\n  cursor: pointer;\n"], ["\n  display: flex;\n  flex-direction: row;\n  justify-content: space-between;\n  padding: 5px;\n  padding-top: 7px;\n  padding-left: 10px;\n  width: 92px;\n  font-weight: 600;\n  background-color: ", ";\n  color: ", ";\n  cursor: pointer;\n"])), function (props) { return polished_1.darken(0.1, props.theme.main); }, function (props) { return props.theme.text; });
var ConsoleCount = styled_components_1.default.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  background-color: ", ";\n  border-radius: 30px;\n  color: black;\n  font-size: 11px;\n  padding: 2px;\n  font-weight: 600;\n  padding-right: 6px;\n  padding-left: 6px;\n  margin-left: 10px;\n"], ["\n  background-color: ", ";\n  border-radius: 30px;\n  color: black;\n  font-size: 11px;\n  padding: 2px;\n  font-weight: 600;\n  padding-right: 6px;\n  padding-left: 6px;\n  margin-left: 10px;\n"])), function (props) { return props.theme.extra.mars; });
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            open: false
        };
        _this.handleClick = function () {
            _this.setState({
                open: !_this.state.open
            });
        };
        _this.clearConsole = function () {
            _this.props.debug.clearLogs();
        };
        return _this;
    }
    Tabs.prototype.render = function () {
        var debug = this.props.debug;
        return (React.createElement(Container, null,
            React.createElement(Handle, null,
                React.createElement(TabHandle, { onClick: this.handleClick },
                    "Console",
                    debug.isLogsAvailable && (React.createElement(ConsoleCount, null, debug.logs.length))),
                React.createElement(ToggleButtons, null,
                    debug.isLogsAvailable && (React.createElement(ToggleButton, { onClick: this.clearConsole },
                        React.createElement(core_1.Tooltip, { content: 'Clear console logs', className: 'pt-dark', intent: core_1.Intent.PRIMARY },
                            React.createElement(Trash, { size: 12, color: 'white' })))),
                    React.createElement(ToggleButton, { onClick: this.handleClick },
                        this.state.open && React.createElement(ChevronDown, { size: 17, color: 'white' }),
                        !this.state.open && React.createElement(ChevronUp, { size: 17, color: 'white' })))),
            this.state.open && React.createElement(consolePanel_1.default, { debug: debug })));
    };
    Tabs = __decorate([
        mobx_react_1.observer
    ], Tabs);
    return Tabs;
}(React.Component));
exports.default = Tabs;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
//# sourceMappingURL=index.js.map