"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_1 = require("mobx");
var remote_1 = require("./remote");
var relay_1 = require("./relay");
var Debugger = /** @class */ (function () {
    function Debugger() {
        var _this = this;
        this.debugUrl = '';
        this.showDebugPanel = false;
        this.running = false;
        this.logs = mobx_1.observable([]);
        remote_1.debuggerExitStream$.subscribe(function () {
            _this.stopDebugger();
        });
        relay_1.loggerStream$.subscribe(function (log) {
            if (typeof log === 'string') {
                _this.logs.push({
                    text: log
                });
            }
            else {
                _this.logs.push(log);
            }
        });
    }
    Debugger.prototype.setDebugUrl = function (url) {
        this.debugUrl = url;
    };
    Debugger.prototype.toggleDebugPanel = function (toggle) {
        this.showDebugPanel = toggle;
    };
    Debugger.prototype.launchInEditor = function (file, test) {
        return __awaiter(this, void 0, void 0, function () {
            var remote;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, remote_1.default];
                    case 1:
                        remote = _a.sent();
                        remote.launchInEditor(file.path, test.line);
                        return [2 /*return*/];
                }
            });
        });
    };
    Debugger.prototype.stopDebugger = function () {
        this.running = false;
    };
    Debugger.prototype.startDebugging = function (node, test) {
        return __awaiter(this, void 0, void 0, function () {
            var remote, debugResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.running = true;
                        return [4 /*yield*/, remote_1.default];
                    case 1:
                        remote = _a.sent();
                        return [4 /*yield*/, remote.startDebugging(node.path, test.name)];
                    case 2:
                        debugResult = _a.sent();
                        this.setDebugUrl(debugResult.url);
                        this.toggleDebugPanel(true);
                        return [2 /*return*/];
                }
            });
        });
    };
    Object.defineProperty(Debugger.prototype, "isLogsAvailable", {
        get: function () {
            return this.logs.length > 0;
        },
        enumerable: true,
        configurable: true
    });
    Debugger.prototype.clearLogs = function () {
        this.logs.clear();
    };
    __decorate([
        mobx_1.observable
    ], Debugger.prototype, "debugUrl", void 0);
    __decorate([
        mobx_1.observable
    ], Debugger.prototype, "showDebugPanel", void 0);
    __decorate([
        mobx_1.observable
    ], Debugger.prototype, "running", void 0);
    __decorate([
        mobx_1.observable
    ], Debugger.prototype, "logs", void 0);
    __decorate([
        mobx_1.computed
    ], Debugger.prototype, "isLogsAvailable", null);
    return Debugger;
}());
exports.Debugger = Debugger;
exports.default = new Debugger();
//# sourceMappingURL=Debugger.js.map