"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_1 = require("mobx");
var Node_1 = require("./Node");
var ExecutionSummary_1 = require("./ExecutionSummary");
var remote_1 = require("./remote");
var relay_1 = require("./relay");
var CoverageSummary_1 = require("./CoverageSummary");
var Tests = /** @class */ (function () {
    function Tests() {
        var _this = this;
        this.nodes = mobx_1.observable([]);
        this.executionSummary = new ExecutionSummary_1.default();
        this.coverageSummary = new CoverageSummary_1.default();
        this.flatNodeMap = new Map();
        remote_1.fileChangeStream$.subscribe(function (_a) {
            var file = _a.file, itBlocks = _a.itBlocks;
            var node = _this.getByPath(file);
            if (node) {
                node.setItBlocks(itBlocks);
                node.setStatus();
            }
        });
        remote_1.fileAddStream$.subscribe(function (_a) {
            var files = _a.files, path = _a.path;
            _this.initialize(files);
            _this.changeCurrentSelection(path);
        });
        remote_1.fileDeleteStream$.subscribe(function (_a) {
            var files = _a.files, path = _a.path;
            var toBeDeleted = _this.flatNodeMap.get(path.toLocaleLowerCase());
            if (toBeDeleted) {
                var parent_1 = toBeDeleted.parent;
                if (parent_1 && parent_1.children) {
                    parent_1.children.remove(toBeDeleted);
                }
            }
        });
        relay_1.testResultStream$.subscribe(function (_a) {
            var test = _a.test, testResult = _a.testResult, aggregatedResult = _a.aggregatedResult;
            _this.handleOnTestResult(test, testResult, aggregatedResult);
        });
        relay_1.runCompleteStream$.subscribe(function (_a) {
            var results = _a.results;
            _this.handleOnRunComplete(results);
        });
        this.readFiles();
    }
    Tests.prototype.initialize = function (files) {
        this.nodes.clear();
        this.flatNodeMap.clear();
        for (var _i = 0, files_1 = files; _i < files_1.length; _i++) {
            var file = files_1[_i];
            var node = Node_1.default.convertToNode(file, this.flatNodeMap).node;
            node.isExpanded = true;
            this.nodes.push(node);
        }
    };
    Tests.prototype.getByPath = function (path) {
        return this.flatNodeMap.get(path.toLowerCase());
    };
    Tests.prototype.changeCurrentSelection = function (path) {
        var nextSelection = this.flatNodeMap.get(path.toLowerCase());
        if (nextSelection) {
            // if there is a previous selection, unselect it
            if (this.selectedTest) {
                this.selectedTest.toggleSelection(false);
            }
            this.selectedTest = nextSelection;
            this.selectedTest.toggleSelection();
        }
    };
    Tests.prototype.collapseTests = function () {
        (this.nodes[0].children || []).forEach(function (child) { return (child.isExpanded = false); });
    };
    Tests.prototype.resetStatus = function () {
        this.flatNodeMap.forEach(function (node) { return node.resetStatus(); });
    };
    Object.defineProperty(Tests.prototype, "failedTests", {
        get: function () {
            return Array.from(this.flatNodeMap)
                .filter(function (_a) {
                var key = _a[0], file = _a[1];
                return file.status === 'failed';
            })
                .map(function (_a) {
                var key = _a[0], file = _a[1];
                return file;
            });
        },
        enumerable: true,
        configurable: true
    });
    Tests.prototype.executeAllItBlocks = function () {
        this.flatNodeMap.forEach(function (file) { return file.execute(); });
    };
    Tests.prototype.reFetchFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remote, files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, remote_1.default];
                    case 1:
                        remote = _a.sent();
                        return [4 /*yield*/, remote.reFetchFiles()];
                    case 2:
                        files = _a.sent();
                        this.initialize(files);
                        return [2 /*return*/];
                }
            });
        });
    };
    Tests.prototype.readFiles = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remote, files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, remote_1.default];
                    case 1:
                        remote = _a.sent();
                        return [4 /*yield*/, remote.getFiles()];
                    case 2:
                        files = _a.sent();
                        this.initialize(files);
                        return [2 /*return*/];
                }
            });
        });
    };
    Tests.prototype.handleOnTestResult = function (test, testResult, aggregatedResult) {
        console.log(testResult);
        var testNode = this.getByPath(test.path);
        if (!testNode) {
            return;
        }
        testNode.executionTime = test.duration || 0;
        for (var _i = 0, _a = testResult.testResults; _i < _a.length; _i++) {
            var assertionResult = _a[_i];
            var itBlock = testNode.getItBlockByTitle(assertionResult.title.trim());
            if (!itBlock) {
                return;
            }
            itBlock.setTimeTaken(assertionResult.duration || 0);
            itBlock.status = assertionResult.status;
            itBlock.failureMessage = assertionResult.failureMessages[0];
            itBlock.stopExecuting();
        }
        testNode.setStatus();
        this.setAggregatedResults(aggregatedResult);
    };
    Tests.prototype.handleOnRunComplete = function (results) {
        this.setAggregatedResults(results);
    };
    Tests.prototype.setAggregatedResults = function (results) {
        this.executionSummary.updateSuitSummary(results.numPassedTestSuites, results.numFailedTestSuites);
        this.executionSummary.updateTestSummary(results.numPassedTests, results.numFailedTests);
        this.executionSummary.updateSnapshotSummary(results.snapshot.matched, results.snapshot.unmatched);
        this.executionSummary.updateTimeTaken(results.startTime);
        if (results.coverageMap) {
            this.coverageSummary.mapCoverage(results.coverageMap);
        }
    };
    __decorate([
        mobx_1.observable
    ], Tests.prototype, "nodes", void 0);
    __decorate([
        mobx_1.observable
    ], Tests.prototype, "selectedTest", void 0);
    __decorate([
        mobx_1.observable
    ], Tests.prototype, "executionSummary", void 0);
    __decorate([
        mobx_1.observable
    ], Tests.prototype, "coverageSummary", void 0);
    __decorate([
        mobx_1.observable
    ], Tests.prototype, "flatNodeMap", void 0);
    __decorate([
        mobx_1.action.bound
    ], Tests.prototype, "changeCurrentSelection", null);
    __decorate([
        mobx_1.action.bound
    ], Tests.prototype, "collapseTests", null);
    __decorate([
        mobx_1.computed
    ], Tests.prototype, "failedTests", null);
    return Tests;
}());
exports.Tests = Tests;
exports.default = new Tests();
//# sourceMappingURL=Tests.js.map