"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var relay_1 = require("./relay");
var util_1 = require("../../engine/util");
var remote_1 = require("./remote");
var mobx_1 = require("mobx");
var Toaster_1 = require("./Toaster");
var VsCodeIntegrator = /** @class */ (function () {
    function VsCodeIntegrator() {
        var _this = this;
        this.vsCodeRootPath = 'vscodepath';
        this.rootPath = 'rootPath';
        relay_1.vscodePluginStream$.subscribe(function (message) {
            if (message.event === 'workspace-path') {
                _this.vsCodeRootPath = message.payload;
                if (_this.rootPath.toLowerCase() === _this.vsCodeRootPath.toLowerCase()) {
                    Toaster_1.show('💡 Connected to VSCode');
                }
            }
        });
        this.getDebugInfo();
        this.pingForVsCodeRootPath();
    }
    VsCodeIntegrator.prototype.startDebug = function (testName, filePath) {
        relay_1.send({
            source: 'majestic',
            event: 'start-debugging',
            payload: {
                program: this.jestExecuablePath,
                fileName: filePath,
                identifier: util_1.getTestPatternForTestName(testName),
                pathToConfig: undefined,
                rootPath: this.rootPath
            }
        });
    };
    Object.defineProperty(VsCodeIntegrator.prototype, "isDebuggerReady", {
        get: function () {
            return this.rootPath.toLowerCase() === this.vsCodeRootPath.toLowerCase();
        },
        enumerable: true,
        configurable: true
    });
    VsCodeIntegrator.prototype.pingForVsCodeRootPath = function () {
        relay_1.send({
            source: 'majestic',
            event: 'get-root-path'
        });
    };
    VsCodeIntegrator.prototype.getDebugInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remote, info;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, remote_1.default];
                    case 1:
                        remote = _a.sent();
                        return [4 /*yield*/, remote.getDebugInfo()];
                    case 2:
                        info = _a.sent();
                        this.jestExecuablePath = info.jestExecuablePath;
                        this.rootPath = info.rootPath;
                        console.log(info);
                        return [2 /*return*/];
                }
            });
        });
    };
    __decorate([
        mobx_1.observable
    ], VsCodeIntegrator.prototype, "vsCodeRootPath", void 0);
    __decorate([
        mobx_1.observable
    ], VsCodeIntegrator.prototype, "rootPath", void 0);
    __decorate([
        mobx_1.computed
    ], VsCodeIntegrator.prototype, "isDebuggerReady", null);
    return VsCodeIntegrator;
}());
exports.VsCodeIntegrator = VsCodeIntegrator;
exports.default = new VsCodeIntegrator();
//# sourceMappingURL=VsCodeIntegrator.js.map