"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var client_1 = require("../../portal/client");
var rxjs_1 = require("rxjs");
exports.fileChangeStream$ = new rxjs_1.Subject();
exports.fileAddStream$ = new rxjs_1.Subject();
exports.fileDeleteStream$ = new rxjs_1.Subject();
exports.debuggerExitStream$ = new rxjs_1.Subject();
var remoteInterface = new Promise(function (resolve) {
    client_1.default('ui', {
        onFileChange: function (file, itBlocks) {
            exports.fileChangeStream$.next({
                file: file,
                itBlocks: itBlocks
            });
            return JSON.stringify({});
        },
        onFileAdd: function (path, files) {
            exports.fileAddStream$.next({
                path: path,
                files: files
            });
            return JSON.stringify({});
        },
        onFileDelete: function (path, files) {
            exports.fileDeleteStream$.next({
                path: path,
                files: files
            });
            return JSON.stringify({});
        },
        onDebuggerExit: function () {
            exports.debuggerExitStream$.next();
            return JSON.stringify({});
        }
    }, function (remote) {
        resolve(remote);
    });
});
exports.default = remoteInterface;
//# sourceMappingURL=remote.js.map