"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WS = require('ws');
var connection;
function getConnection() {
    if (connection) {
        return connection;
    }
    connection = initializeConnection();
    return connection;
}
exports.getConnection = getConnection;
function initializeConnection() {
    return new Promise(function (resolve, reject) {
        var wss = new WS.Server({ port: 7777 });
        wss.on('connection', function (ws) {
            ws.on('message', function (message) {
                wss.clients.forEach(function (client) {
                    if (client !== ws && client.readyState === WS.OPEN) {
                        client.send(message);
                    }
                });
            });
            resolve(ws);
        });
    });
}
//# sourceMappingURL=relay.js.map